#include <stdio.h>

  /* Ucitava n i pise broj particija broja n,
     tj. broj rastava broja n u sumu nepadajucih
     prirodnih brojeva.
     Osnovni rekurzivni algoritam zbrajanjem.
     Ispisuje i "trag" poziva.
  */

int particije(int suma, int prvi)
{
    int i, broj = 0;

    printf("  suma = %d,  prvi = %d\n", suma, prvi);

    if (suma == 0) return 1;
        /* else */
    for (i = prvi; i <= suma; ++i)
            /* Sljedeci pribrojnik je i,
               rekurzivni poziv za suma - i. */
        broj += particije(suma - i, i);
    return broj;
}

int main(void)
{
    int n;

    printf(" Upisi prirodni broj n: ");
    scanf("%d", &n);

    printf("\n Broj particija p(%d) = %d\n",
           n, particije(n, 1) );

    return 0;
}
