#include <stdio.h>

  /* Visedimenzionalna polja - Primjer:
     2-dimenzionalna polja = matrice.
     Poredak spremanja i inicijalizacija. */

int main(void)
{
    static double m[2][3]
           = {1.0, 2.0, 3.0, 4.0, 5.0, 6.0};
    int i, j;

        /* Ispis pokazivaca (adresa) i duljina polja:
           cijela matrica m, zatim m[0], m[1]. */

    printf(" Matrica m:\n");
    printf("     m = %p,  duljina = %2u\n", m, sizeof(m));

    printf("\n");
    printf(" Redovi m[0], m[1]:\n");
    printf("  m[0] = %p,  duljina = %2u\n", m[0], sizeof(m[0]));
    printf("  m[1] = %p,  duljina = %2u\n", m[1], sizeof(m[1]));

        /* Ispis elemenata - vrijednosti i adresa. */
    printf("\n");
    printf(" Elementi:\n");
    for (i = 0; i < 2; ++i)
        for (j = 0; j < 3; ++j)
            printf("  m[%d][%d] = %g,  adresa = %p\n",
                   i, j, m[i][j], &m[i][j]);

    return 0;
}
