#include <stdio.h>
#include <string.h>

  /* Citanje jednog reda ulaza u string:
     funkcija fgets. */

int main(void)
{
        /* U polje s stane najvise 19 znakova sadrzaja stringa, tako da IZA
           sadrzaja ima jos jedno mjesto za nul-znak (\0) = kraj stringa. */
    char s[20];
        /* Duljina ucitanog stringa (strlen), bez nul-znaka. */
    unsigned int d;

    printf("Upisite string u jednom redu:\n");

        /* Citanje jednog reda ulaza u string.
           Funkcija fgets ucita kraj reda i SPREMI ga u string.
           Velicina polja s kao buffera za citanje = sizeof(s) = 20. */
    fgets(s, sizeof(s), stdin);

        /* Duljina stringa. */
    d = strlen(s);

        /* Ispis ucitanog stringa i duljine (strlen). */
    printf("\nUcitani string (pocinje u sljedecem redu):\n%s\n", s);
    printf("\nDuljina stringa = %u\n", d);

        /* Popravak stringa = izbacivanje nul-znaka, ako ga ima.
           Pogledamo predzadnji znak u stringu, onaj ispred \0, na mjestu
           s[ strlen(s) - 1 ]. Ako je jednak \n, onda stavimo \0 na njegovo
           mjesto, sto skrati string za jedan znak. */
    if (s[d - 1] == '\n') s[d - 1] = '\0';

        /* Duljina stringa. */
    d = strlen(s);

        /* Ispis popravljenog stringa i duljine (strlen). */
    printf("\nPopravljeni string (pocinje u sljedecem redu):\n%s\n", s);
    printf("\nDuljina stringa = %u\n", d);

    return 0;
}
