#include <stdio.h>
#include <string.h>

  /* Citanje jednog reda ulaza u string:
     funkcija getchar. */

int main(void)
{
        /* U polje s stane najvise 19 znakova sadrzaja stringa, tako da IZA
           sadrzaja ima jos jedno mjesto za nul-znak (\0) = kraj stringa. */
    char s[20];
        /* Duljina ucitanog stringa (strlen), bez nul-znaka. */
    unsigned int d;
        /* Znak kod citanja. */
    char c;
        /* Indeks znaka kod citanja. */
    int i;

    printf("Upisite string u jednom redu:\n");

        /* Citanje jednog reda ulaza u string.
           Funkcija getchar cita znak-po-znak do kraja reda. Ucitamo i
           kraj reda (za prekid petlje), ali ga NE spremimo u string.
           Citamo najvise 19 = sizeof(s) - 1 znakova i dodajemo nul-znak. */
    i = 0;
    while (i < 19 && (c = getchar()) != '\n')
        s[i++] = c;
    s[i] = '\0';

        /* Duljina stringa. */
    d = strlen(s);

        /* Ispis ucitanog stringa i duljine (strlen). */
    printf("\nUcitani string (pocinje u sljedecem redu):\n%s\n", s);
    printf("\nDuljina stringa = %u\n", d);

    return 0;
}
