#include <stdio.h>

  /* Produkt matrice i vektora s typedef. */

#define MAX_DIM 10

    /* Definicije tipova. */

typedef double skalar;
typedef skalar vektor[MAX_DIM];
typedef vektor matrica[MAX_DIM];

    /* Funkcija za produkt matrice i vektora. */

void prod_mat_vek(int m, int n, matrica A,
                  vektor x, vektor y)
{
    int i, j;

        /* Mnozenje matrice i vektora. */
    for (i = 0; i < m; ++i) {
        y[i] = 0.0;
        for (j = 0; j < n; ++j)
            y[i] += A[i][j] * x[j];
        }
    return;
}

    /* Glavni program. */

int main(void)
{
    matrica A;
    vektor x, y;
    int m, n;    /* Stvarne dimenzije matrice A. */

    m = 2;  n = 2;
    A[0][0] = 2.0;  A[0][1] = 1.0;  x[0] = 1.0;
    A[1][0] = 0.0;  A[1][1] = 1.0;  x[1] = 2.0;

    prod_mat_vek(m, n, A, x, y);

    printf(" y[0] = %g, y[1] = %g\n", y[0], y[1]);

    return 0;
}
