/* ======================================================================== */

lista merge_sort(lista prvi)
{
        /* Sortira listu Merge_Sort algoritmom. */

    lista zadnji, prvi_2;

        /* Test na praznu ili jednoclanu listu. */
    if ((prvi == NULL) || (prvi->sljed == NULL))
        return prvi;

        /* U nastavku obrade, lista ima bar dva elementa. */

        /* ``Raspolovi'' listu. Pokazivac zadnji pokazuje na zadnjeg
           u prvom dijelu. Pokazivac prvi_2 je trenutno pomocni
           i sluzi za raspolavljanje liste. */
    zadnji = prvi;
    prvi_2 = prvi->sljed;

        /* Pomicemo zadnjeg za JEDNO mjesto, a prvi_2 za DVA mjesta,
           sve dok prvi_2 ne stigne do kraja liste. */
    while ((prvi_2 != NULL) && (prvi_2->sljed != NULL)) {
        zadnji = zadnji->sljed;
        prvi_2 = prvi_2->sljed->sljed;
    }

        /* Pokazivac zadnji sad korektno pokazuje na zadnjeg u prvom
           dijelu. Pokazivac prvi_2 postavljamo na prvog u drugom
           dijelu (prvi iza zadnjeg) i korektno zavrsavamo prvi dio. */
    prvi_2 = zadnji->sljed;
    zadnji->sljed = NULL;

        /* Rekurzivno sortiranje obje liste i sortirano spajanje. */
    prvi = merge(merge_sort(prvi),
                 merge_sort(prvi_2));

    return prvi;
}

/* ======================================================================== */
