#include <stdio.h>
#include <stdlib.h>

  /* Primjer za funkciju srand (postavljanje sjemena za rand). */

    /* Postavlja sjeme za rand() na seed i
       ispisuje prvih n slucajnih brojeva
       iz rand(), s tim sjemenom. */

void ispis_rand(unsigned int seed, int n)
{
    int i;

    srand(seed);

    printf("\n Sjeme (seed) za rand = %u\n", seed);
    printf(" Slucajni brojevi:\n");

    for (i = 1; i <= n; ++i)
        printf(" %6d\n", rand());

    return;
}

int main(void)
{
    unsigned int seed;

    printf("RAND_MAX = %d\n", RAND_MAX);    /* 32767 */

    ispis_rand(0u, 10);
    ispis_rand(1u, 10);
    ispis_rand(2u, 10);
    ispis_rand(3u, 10);
    ispis_rand(4u, 10);
    ispis_rand(5u, 10);

    printf("\n Upisi sjeme: ");
    scanf("%u", &seed);
    ispis_rand(seed, 10);

    return 0;
}
