#include <stdio.h>
#include <stdlib.h>

  /* Vjezbe, Zadatak 2.3.5. */

  /* Globalno (dinamicki alocirano) polje sumandi sluzi za ispis svih suma,
     sto se u zadatku NE TRAZI!
     Dakle, rjesenje zadatka je bez tog polja i pomocnog parametra n
     (datoteka 4.c), a ovdje je dodano radi preglednosti! */

int *sumandi;

int part(int x, int prvi, int n)
{
    int cnt = 0, i;

    if (x < 0) return 0;    /* Ovako ne ide. */

        /* Jedan uspjesan nacin - ispis prikaza kao sume. */
    if (x == 0) {
        printf("%d", sumandi[0]);
        for (i = 1; i < n; i++) printf(" + %d", sumandi[i]);
        printf("\n");
        return 1;
    }

        /* Kreni od zadnjeg koristenog sumanda (tj. gledamo
           samo uzlazne poretke, pa nema ponavljanja): */
    if (prvi <= 2) {
        sumandi[n] = 2;
        cnt += part(x - 2, 2, n + 1);
    }
    if (prvi <= 3) {
        sumandi[n] = 3;
        cnt += part(x - 3, 3, n + 1);
    }
    if (prvi <= 5) {
        sumandi[n] = 5;
        cnt += part(x - 5, 5, n + 1);
    }

    return cnt;
}

int main(void)
{
    int n, p;

    printf("Upisite broj n: "); scanf("%d", &n);

        /* Dinamicka alokacija globalnog polja sumandi. */
    sumandi = (int*) malloc(n / 2 * sizeof(int));

        /* Prvi sumand za koji testiramo je 2.
           Indeks prvog sljedeceg sumanda je 0. */
    p = part(n, 2, 0);
    printf("Takvih rastava ima %d.\n", p);

        /* Oslobadjanje alocirane memorije za polje sumandi. */
    free(sumandi);

    return 0;
}
