#include <stdio.h>

  /* Obrada polja preko indeksa i preko pokazivaca (adresa).
     Ako zaista radimo s poljem, indeksi su prirodni,
     a pokazivaci (adrese) se TESKO citaju.
     Pogledati ekvivalentne petlje u glavnom programu. */

void pisi(int x[], int n)
{
    int i;

    for (i = 0; i < n; ++i)
        printf(" x[%d] = %2d\n", i, x[i]);

    return;
}

int main(void)
{
    int i, *pi, x[10];

        /* Obrada polja preko indeksa. */
    for (i = 0; i < 10; ++i)
        x[i] = i;

    printf("Polje x:\n");
    pisi(x, 10);

        /* Obrada polja preko pokazivaca (adresa). */
    for (i = 0, pi = &x[0]; pi <= &x[9]; ++pi, ++i)
        *pi = i; 

    printf("Polje x:\n");
    pisi(x, 10);

    return 0;
}
