#include <stdio.h>
#include <math.h>

  /* Pokazivac na funkciju - Primjer 1b.
     Numericka integracija funkcije
     obicnom trapeznom formulom.
     Stvarni argument je ime funkcije.
     U integraciji koristimo pokazivac f, a ne *f
     (tj. bez dereferenciranja). */

double integracija(double, double,
                   double (*)(double));

int main(void)
{
    printf("Sin: %f\n", integracija(0, 1, sin));
    printf("Cos: %f\n", integracija(0, 1, cos));

    return 0;
}

double integracija(double a, double b,
                   double (*f)(double))
{
    return 0.5 * (b - a) * ( f(a) + f(b) );
}
