#include <stdio.h>

/****************************************************************************/

  /* Uzlazno sortiranje izborom ekstrema.
     Dovodimo najveci element na kraj.
     Pamti indeks i vrijednost najveceg.
     Skracena zamjena, bez temp.
     Vanjska petlja je uzlazna (a ne silazna). */

void selection_sort(int x[], int n)
{
    int i, j, ind_max, j_max, x_max;

    for (i = 0; i < n - 1; ++i) {
        ind_max = 0;
        x_max = x[0];
        j_max = n - i - 1;
        for (j = 1; j <= j_max; ++j) {
            if (x[j] > x_max) {
                ind_max = j;
                x_max = x[j];
            }
        }
        if (j_max != ind_max) {
            x[ind_max] = x[j_max];
            x[j_max] = x_max;
        }
    }

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    selection_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
